//+-------------------------------------------+
//|             Buldozer_A12_MishganTest2.mq4 |
//|                  Copyright  2010, ir0407 |
//|                    Edited by skumen, 2011 |
//|                    Edited by al22bag 2012 |
//+-------------------------------------------+
#property copyright "Copyright  2010, ir0407"
#property link      "wlmaster@mail.ru"
#include <stderror.mqh>
#include <stdlib.mqh>
//-------------------------------------
extern string GenSet             = "General Settings";
extern bool   Debug              = false;
extern int    MN_Buy             = 1;     //   (      )
extern int    MN_Sell            = 2;     //   (      )
extern int    MaxTrades          = 8;     //       ( )
extern int    MaxBalanceLoss     = 100;    //  %%   ,        
extern int    MaxBalanceProfit   = 1000;   //  %%   ,        
//-------------------------------------
extern string SigSet             = "Signals Settings";
extern bool   ManualFirstOrder   = false; // ! True,  !
                                          // !     0! 
                                          //    ,   
extern int    SignalMode         = 3;     // 0-  ,
                                          // 1-   ir0407,
                                          // 2-   scumen,
// ! -   SignalMode = 3!     // 3-  " "
extern double DeltaBarPrice      = 50;    //        
extern int    NumberOfBars       = 12;     //   ,  1: 2-3 ,  3:  3 ,   
extern int    TF_Bars            = 3;     // 0-   , 1-M1, 2-M5, 3-M15, 4-M30, 5-H1, 6-H4, 7-D1, 8-W1, 9-MN
extern int    EnforceOppLot      = 1;     //  1,       StartEnforcedLot,   
                                          //  , ,  
extern int    StartEnforcedLot   = 1;     //  o      
extern int    StopEnforcedLot    = 8;     //  o      
//-------------------------------------
extern string LotSet             = "Lot Settings";
extern double InitLot            = 0.1;   //     
extern int    LotDecimal         = 2;     //      
extern int    LotMode            = 0;     // 0 - , 1- A
extern double LotExp             = 2;   //        , :   0.1, : 0.16, 0.26, 0.43 ...
                                          //     1
extern double LotInc             = 0;     //        , :   0.1, : 0.2, 0.3, 0.4 ...
                                          //     0
extern double MaxLot             = 0.5;     //  
extern int    OppLot_On_Off      = 1;     //           
extern int    StartOppLots       = 2;     //       ,     
extern double OppLotExp          = 1.3;   //        
//-------------------------------------
extern string StepSet            = "PipStep Settings";
extern int    InitPipStep        = 40;
extern int    PipStepMode        = 1;     // 0 - , 1- A
extern double PipStepExp         = 1;   //   ,     1
extern int    PipStepInc         = 30;     //   ,     0
extern int    StartDynStep       = 4;     //     
//-------------------------------------
extern string TPSet              = "TakeProfit Settings";
extern int    InitTP             = 20;   //       
extern int    LastTP_On_Off      = 0;     // 0-Off, 1-On,       
extern int    StartLastTP        = 8;     //        
extern int    LastTP             = 30;   //    
//-------------------------------------
string   ExpertName = "Buldozer_A12_MishganTest2";
datetime NewBarOpenTime;
double   LastTickTime;
int      Slippage, Error = 0;
int      mper[10] = {0,1,5,15,30,60,240,1440,10080,43200};

// ----- EA initialization function -----
int init()
{
  NewBarOpenTime = Time[0];
  return(0);
}
// ----- EA deinitialization function -----
int deinit()
{
  return(0);
}
// ----- EA start function -----
int start()
{
  int    Signal, Ticket;
  int    TotalOrders, BuyOrders, SellOrders;
  int    PipStepBuy, PipStepSell;
  double NewLotBuy, NewLotSell;
  double LastBuyPrice, LastSellPrice, NewTPPrice;

  //   ,      
  if(NewBarOpenTime == Time[0]) return(0);   //   

  //    ,       
  NewBarOpenTime = Time[0];
  LastTickTime = MarketInfo(Symbol(),MODE_TIME);
  Slippage = MarketInfo(Symbol(), MODE_SPREAD);
  //------------------------------------
  if(AccountEquity() >= AccountBalance() * (100 + MaxBalanceProfit) / 100) 
  {//  >= MaxBalanceProfit  -     
    CloseThisSymbolAll();
    Print("Closing All - reached MaxBalanceProfit = ", MaxBalanceProfit);
    return(0);    
  }
  if(AccountEquity() <= AccountBalance() * (100 - MaxBalanceLoss) / 100)
  {//  >= MaxBalanceLoss  -     
    CloseThisSymbolAll();
    Print("Closing All - reached MaxBalanceLoss = ", MaxBalanceLoss, "%");
    return(0);    
  }
  //----------------------------
  TotalOrders = CountOfOrders(); 
  //----------------------------
  if(TotalOrders == 0) //     
  { 
    if(ManualFirstOrder)
    {
      Print("TotalOrders == 0, Manual Mode ON");
      Print("Waiting for Manual BUY & SELL Orders");
      return(0);
    }
    if(!(ManualFirstOrder)) Signal = GetSignal();
    switch(Signal)
    { 
      case 1: //  
        if(Debug) Print("TotalOrders = 0, Signal: BUY, Sending 1st BUY order...");
        Ticket = SendMarketOrder(OP_BUY, InitLot, 0, 0, MN_Buy, ExpertName + "-" + (TotalOrders+1) + "-" + 0, Error);
        if(Ticket > 0)
          if(OrderSelect(Ticket, SELECT_BY_TICKET))
          {
            NewTPPrice = OrderOpenPrice() + (InitTP * Point);
            ModifyOrder(NewTPPrice);
          }
        break;
      case -1: //  
        if(Debug) Print("TotalOrders = 0, Signal: SELL, Sending 1st SELL order...");
        Ticket = SendMarketOrder(OP_SELL, InitLot, 0, 0, MN_Sell, ExpertName + "-" + (TotalOrders+1) + "-" + 0, Error);
        if(Ticket > 0)
          if(OrderSelect(Ticket, SELECT_BY_TICKET))
          {
            NewTPPrice = OrderOpenPrice() - (InitTP * Point);
            ModifyOrder(NewTPPrice);
          }
        break;
      default:
        //if(Debug) Print("Signal = ",Signal,", waiting for new bar...");
        break;
    }//exit switch(Signal)
    return(0);
  }//exit if(TotalOrders == 0)
  //-----------------
  if(TotalOrders > 0) //        
  { 
    BuyOrders  = CountOfBuy();
    SellOrders = CountOfSell();
    //----------------
    if(BuyOrders == 0)
    {
      if(EnforceOppLot == 0)
      {
        if(ManualFirstOrder)
        {
          Print("Buy Orders == 0, Manual Mode ON");
          Print("Waiting for Manual BUY Order");
        }
        if(!(ManualFirstOrder)) Signal = GetSignal();
        if(Signal == 1)
        {
          if(Debug) Print("BuyOrders = 0, Signal: BUY");
          if((OppLot_On_Off == 0) || (SellOrders < StartOppLots))
          {
            NewLotBuy = InitLot;
            if(Debug) Print("OppLots OFF, Sending 1st BUY order, InitLot = ",NewLotBuy);
          }
          if((OppLot_On_Off == 1) && (SellOrders >= StartOppLots))
          {
            NewLotBuy = NormalizeDouble(FindLastLotSell() * OppLotExp, LotDecimal);
            if(NewLotBuy < InitLot) NewLotBuy = InitLot;
            if(NewLotBuy > MaxLot)  NewLotBuy = MaxLot;
            if(Debug) Print("OppLots ON, Sending 1st BUY order, OppLot = ",NewLotBuy);
          }      
          Ticket = SendMarketOrder(OP_BUY, NewLotBuy, 0, 0, MN_Buy, ExpertName + "-" + (BuyOrders+1) + "-" + 0, Error);
          if(Ticket > 0)
            if(OrderSelect(Ticket, SELECT_BY_TICKET))
            {
              NewTPPrice = OrderOpenPrice() + (InitTP * Point);
              ModifyOrder(NewTPPrice);
            }
        }//exit if(Signal == 1)
      }//exit if(EnforceOppLot == 0)
      //--------------------
      if(EnforceOppLot == 1)
      {
        if(SellOrders < StartEnforcedLot)
          if(Debug) Print("Waiting for SellOrders to reach StartEnforcedLot");
        if((SellOrders >= StartEnforcedLot) && (SellOrders < StopEnforcedLot))
        {
          if(Debug) Print("(EnforceOppLot == 1) && (SellOrders >= StartEnforcedLot) && (SellOrders < StopEnforcedLot)");
          if(Debug) Print("Force Open first BUY Order");
          if((OppLot_On_Off == 0) || (SellOrders < StartOppLots))
          {
            NewLotBuy = InitLot;
            if(Debug) Print("OppLots OFF, Sending 1st BUY order, InitLot = ",NewLotBuy);
          }
          if((OppLot_On_Off == 1) && (SellOrders >= StartOppLots))
          {
            NewLotBuy = NormalizeDouble(FindLastLotSell() * OppLotExp, LotDecimal);
            if(NewLotBuy < InitLot) NewLotBuy = InitLot;
            if(NewLotBuy > MaxLot)  NewLotBuy = MaxLot;
            if(Debug) Print("OppLots ON, Sending 1st BUY order, OppLot = ",NewLotBuy);
          }      
          Ticket = SendMarketOrder(OP_BUY, NewLotBuy, 0, 0, MN_Buy, ExpertName + "-" + (BuyOrders+1) + "-" + 0, Error);
          if(Ticket > 0)
            if(OrderSelect(Ticket, SELECT_BY_TICKET))
            {
              NewTPPrice = OrderOpenPrice() + (InitTP * Point);
              ModifyOrder(NewTPPrice);
            }
        }//exit if(SellOrders >= StartEnforcedLot)
      }//exit if(EnforceOppLot == 1)
    }//exit if(BuyOrders == 0)
    //---------------
    if(BuyOrders > 0)
    { 
      LastBuyPrice = FindLastBuyPrice();
      //-----    -----
      if(BuyOrders < StartDynStep) PipStepBuy = InitPipStep;
      if(BuyOrders >= StartDynStep)
      {
        if(PipStepMode == 0) //Geom
          PipStepBuy = NormalizeDouble(InitPipStep * MathPow(PipStepExp,(BuyOrders-StartDynStep+1)),0);
        if(PipStepMode == 1) //Arith
          PipStepBuy = NormalizeDouble(InitPipStep + MathPow(PipStepInc,(BuyOrders-StartDynStep+1)),0);
      }
      //-------------------------------------------
      if(Ask < LastBuyPrice - (PipStepBuy * Point)) //     PipStepBuy
      { 
        if(BuyOrders < MaxTrades)
        {
          //-----    -----
          if(LotMode == 0) // Geom
            NewLotBuy = NormalizeDouble(FindLastLotBuy() * LotExp, LotDecimal);
          if(LotMode == 1) // Arith
            NewLotBuy = NormalizeDouble(FindLastLotBuy() + LotInc, LotDecimal);
          if(NewLotBuy > MaxLot) NewLotBuy = MaxLot;
          //----------------------------------
          if(Debug) Print("Sending BUY Order Number ",BuyOrders + 1,", NewLotBuy = ",NewLotBuy);
          Ticket = SendMarketOrder(OP_BUY, NewLotBuy, 0, 0, MN_Buy, ExpertName + "-" + (BuyOrders + 1) + "-" + DoubleToStr((LastBuyPrice - Ask) / Point, 0), Error);
          if(Ticket > 0)
          { 
            if((LastTP_On_Off == 0) || (BuyOrders < StartLastTP))
            {
              NewTPPrice = NormalizeDouble(CalculateAveragePriceBuy() + (InitTP * Point), Digits);
              if(Debug) Print("LastTP Off, Modifying all BUY orders");
              for(int i1 = 0; i1 < OrdersTotal(); i1++) 
                if(OrderSelect(i1, SELECT_BY_POS, MODE_TRADES))
                  if(OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Buy)
                    if(OrderType()== OP_BUY) 
                      ModifyOrder(NewTPPrice);
            }//exit if((LastTP_On_Off == 0) || (BuyOrders < StartLastTP))
            if((LastTP_On_Off == 1) && (BuyOrders >= StartLastTP))
            {
              if(Debug) Print("LastTP On, BuyOrders = ",BuyOrders,", StartLastTP = ",StartLastTP);
              if(Debug) Print("Modifying Last BUY order");
              if(OrderSelect(Ticket, SELECT_BY_TICKET))
              {
                NewTPPrice = OrderOpenPrice() + (LastTP * Point);
                ModifyOrder(NewTPPrice);
              }
            }//exit if((LastTP_On_Off == 1) && (BuyOrders >= StartLastTP))
          }//exit if(Ticket > 0)
        }//exit if(BuyOrders < MaxTrades)
      }//exit if(Ask < LastBuyPrice - (PipStepBuy * Point))
    }//exit if(BuyOrders > 0)
    //--------------------------------
    if(SellOrders == 0)
    { 
      if(EnforceOppLot == 0)
      {
        if(ManualFirstOrder)
        {
          Print("Sell Orders == 0, Manual Mode ON");
          Print("Waiting for Manual SELL Order");
        }
        if(!(ManualFirstOrder)) Signal = GetSignal();
        if(Signal == -1)
        {
          if(Debug) Print("SellOrders = 0, Signal: SELL");
          if(Debug) Print("Sending 1st SELL order, InitLot = ",InitLot);
          if((OppLot_On_Off == 0) || (BuyOrders < StartOppLots))
          {
            NewLotSell = InitLot;
            if(Debug) Print("OppLots OFF, Sending 1st SELL order, InitLot = ",NewLotSell);
          }
          if((OppLot_On_Off == 1) && (BuyOrders >= StartOppLots))
          {
            NewLotSell = NormalizeDouble(FindLastLotBuy() * OppLotExp, LotDecimal);
            if(NewLotSell < InitLot) NewLotSell = InitLot;
            if(NewLotSell > MaxLot)  NewLotSell = MaxLot;
            if(Debug) Print("OppLots ON, Sending 1st SELL order, OppLot = ",NewLotSell);
          }                 
          Ticket = SendMarketOrder(OP_SELL, NewLotSell, 0, 0, MN_Sell, ExpertName + "-" + (SellOrders+1) + "-" + 0, Error);
          if(Ticket > 0)
            if(OrderSelect(Ticket, SELECT_BY_TICKET))
            {
              NewTPPrice = OrderOpenPrice() - (InitTP * Point);
              ModifyOrder(NewTPPrice);
            }
        }//exit (Signal == -1)
      }//exit if(EnforceOppLot == 0)
      //--------------------
      if(EnforceOppLot == 1)
      {
        if(BuyOrders < StartEnforcedLot)
          if(Debug) Print("Waiting for BuyOrders to reach StartEnforcedLot");
        if((BuyOrders >= StartEnforcedLot) && (BuyOrders < StopEnforcedLot))
        {
          if(Debug) Print("(EnforceOppLot == 1) && (BuyOrders >= StartEnforcedLot) && (BuyOrders < StopEnforcedLot)");
          if(Debug) Print("Force Open first SELL Order");
          if((OppLot_On_Off == 0) || (BuyOrders < StartOppLots))
          {
            NewLotSell = InitLot;
            if(Debug) Print("OppLots OFF, Sending 1st SELL order, InitLot = ",NewLotSell);
          }
          if((OppLot_On_Off == 1) && (BuyOrders >= StartOppLots))
          {
            NewLotSell = NormalizeDouble(FindLastLotBuy() * OppLotExp, LotDecimal);
            if(NewLotSell < InitLot) NewLotSell = InitLot;
            if(NewLotSell > MaxLot)  NewLotSell = MaxLot;
            if(Debug) Print("OppLots ON, Sending 1st SELL order, OppLot = ",NewLotSell);
          }                 
          Ticket = SendMarketOrder(OP_SELL, NewLotSell, 0, 0, MN_Sell, ExpertName + "-" + (SellOrders+1) + "-" + 0, Error);
          if(Ticket > 0)
            if(OrderSelect(Ticket, SELECT_BY_TICKET))
            {
              NewTPPrice = OrderOpenPrice() - (InitTP * Point);
              ModifyOrder(NewTPPrice);
            }
        }//exit if(BuyOrders >= StartEnforcedLot)
      }//exit if(EnforceOppLot == 1)
    }//exit if(SellOrders == 0)
    //----------------
    if(SellOrders > 0)
    {     
      LastSellPrice = FindLastSellPrice();
      //-----    -----
      if(SellOrders < StartDynStep) PipStepSell = InitPipStep;
      if(SellOrders >= StartDynStep)
      {
        if(PipStepMode == 0) //Geom
          PipStepSell = NormalizeDouble(InitPipStep * MathPow(PipStepExp,(SellOrders-StartDynStep+1)),0);
        if(PipStepMode == 1) //Arith
          PipStepSell = NormalizeDouble(InitPipStep + MathPow(PipStepInc,(SellOrders-StartDynStep+1)),0);
      }
      //---------------------------------------------
      if(Bid > LastSellPrice + (PipStepSell * Point)) //     PipStepSell
      {   
        if(SellOrders < MaxTrades)
        {
          //-----    -----
          if(LotMode == 0) // Geom
            NewLotSell = NormalizeDouble(FindLastLotSell() * LotExp, LotDecimal);
          if(LotMode == 1) // Arith
            NewLotSell = NormalizeDouble(FindLastLotSell() + LotInc, LotDecimal);
          if(NewLotSell > MaxLot) NewLotSell = MaxLot;
          //----------------------------------
          if(Debug) Print("Sending SELL Order Number ",SellOrders + 1,", NewLotSell = ",NewLotSell);
          Ticket = SendMarketOrder(OP_SELL, NewLotSell, 0, 0, MN_Sell, ExpertName + "-" + (SellOrders + 1) + "-" + DoubleToStr((Bid - LastSellPrice) / Point, 0), Error);
          if(Ticket > 0)
          { 
            if((LastTP_On_Off == 0) || (SellOrders < StartLastTP))
            {
              NewTPPrice = NormalizeDouble(CalculateAveragePriceSell() - (InitTP * Point), Digits);
              if(Debug) Print("LastTP Off, Modifying all SELL orders");
              for(int i2 = 0; i2 < OrdersTotal(); i2++) 
                if(OrderSelect(i2, SELECT_BY_POS, MODE_TRADES))
                  if(OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Sell)
                    if(OrderType()== OP_SELL) 
                      ModifyOrder(NewTPPrice);
            }//exit if((LastTP_On_Off == 0) || (SellOrders < StartLastTP))
            if((LastTP_On_Off == 1) && (SellOrders >= StartLastTP))
            {
              if(Debug) Print("LastTP On, SellOrders = ",SellOrders,", StartLastTP = ",StartLastTP);
              if(Debug) Print("Modifying Last SELL order");
              if(OrderSelect(Ticket, SELECT_BY_TICKET))
              {
                NewTPPrice = OrderOpenPrice() - (LastTP * Point);
                ModifyOrder(NewTPPrice);
              }
            }//exit if((LastTP_On_Off == 0) || (SellOrders >= StartLastTP))
          }//exit if(Ticket > 0)
        }//exit if(SellOrders < MaxTrades)
      }//exit if(Bid > LastSellPrice + (PipStepSell * Point))
    }//exit if(SellOrders > 0)
    return(0);
  }// exit if(TotalOrders > 0)
  return(0);
}// exit start function
//-----------------------
void CloseThisSymbolAll()
{ 
  int error;
  for(int i = 0; i < OrdersTotal(); i++) //for(cnt = OrdersTotal() - 1; cnt >= 0; cnt--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderSymbol() != Symbol() || (OrderMagicNumber() != MN_Buy && OrderMagicNumber() != MN_Sell))
        continue;
      if(OrderSymbol() == Symbol())
      {
        if(OrderMagicNumber() == MN_Buy && OrderType() == OP_BUY)
        {
          Error = OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Bid, Digits), Slippage, Blue);
          if(Error == 1) 
            Print("BuyOrder # ", OrderTicket(), " Closed OK"); 
          if(error != 1)
            Print("Error Closing BuyOrder # ", OrderTicket(), " Trying again");
        }
        if(OrderMagicNumber() == MN_Sell && OrderType() == OP_SELL)
        {
          Error = OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(Ask, Digits), Slippage, Red);
          if(Error == 1) 
            Print("SellOrder # ", OrderTicket(), " Closed OK"); 
          if(error != 1)
            Print("Error Closing SellOrder # ", OrderTicket(), " Trying again");
        }
      } // Exit if(OrderSymbol() == Symbol())
    Sleep(2000);
    }
  }
  return;
}
//-----------------
int CountOfOrders()
{
  int count = 0;
  for(int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if((OrderMagicNumber() == MN_Buy)||(OrderMagicNumber() == MN_Sell)) 
          if((OrderType() == OP_SELL)||(OrderType() == OP_BUY)) 
            count++;
  //if(Debug) Print("TotalOrders = ",count);
  return(count);
}
//--------------
int CountOfBuy()
{
  int count = 0;
  for(int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN_Buy) 
          if(OrderType() == OP_BUY) 
            count++;
  //if(Debug) Print("BuyOrders = ",count);
  return(count);
}
//---------------
int CountOfSell()
{
  int count = 0;
  for(int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN_Sell) 
          if(OrderType() == OP_SELL) 
            count++;
  //if(Debug) Print("SellOrders = ",count);
  return(count);
}
//---------------------
double FindLastLotBuy()
{ 
  int ticket = 0;
  double lot = 0;    
  for(int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol()) 
        if(OrderType() == OP_BUY)
          if(OrderMagicNumber() == MN_Buy) 
            if(OrderTicket() > ticket)
            {
              ticket = OrderTicket();
              lot = OrderLots();
            }
  if(Debug) Print("LastLotBuy = ", lot);
  return(lot);
}
//----------------------
double FindLastLotSell()
{ 
  int ticket = 0;
  double lot = 0;    
  for(int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol()) 
        if(OrderType() == OP_SELL)
          if(OrderMagicNumber() == MN_Sell) 
            if(OrderTicket() > ticket)
            {
              ticket = OrderTicket();
              lot = OrderLots();
            }
  if(Debug) Print("LastLotSell = ", lot);
  return(lot);
}
//-----------------------
double FindLastBuyPrice()
{
  double LastBuyPrice;
  int LastBuyTicket;
  int ticket = 0;
  for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--)
    if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN_Buy) 
          if(OrderType() == OP_BUY) 
          {
            LastBuyTicket = OrderTicket();
            if(LastBuyTicket > ticket) 
            {
              LastBuyPrice = OrderOpenPrice();
              ticket = LastBuyTicket;
            }
          }
//  if(Debug) Print("LastBuyPrice = ",LastBuyPrice);
  return(LastBuyPrice);
}
//------------------------
double FindLastSellPrice()
{
  double LastSellPrice;
  int LastSellTicket;
  int ticket = 0;
  for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--)
    if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN_Sell) 
          if(OrderType() == OP_SELL) 
          {
            LastSellTicket = OrderTicket();
            if(LastSellTicket > ticket) 
            {
              LastSellPrice = OrderOpenPrice();
              ticket = LastSellTicket;
            }
          }
//  if(Debug) Print("LastSellPrice = ",LastSellPrice);
  return(LastSellPrice);
}
//+------------------------------------------------------------------+
double CalculateAveragePriceBuy()
{
  double Result = 0;
  double AveragePrice = 0;
  double Count = 0;
  for(int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN_Buy)
          if(OrderType() == OP_BUY) 
          {
            AveragePrice += OrderOpenPrice() * OrderLots();
            Count += OrderLots();
          }
  if(AveragePrice > 0 && Count > 0)
    Result = NormalizeDouble(AveragePrice / Count, Digits);
  return(Result);
}
//+------------------------------------------------------------------+
double CalculateAveragePriceSell()
{
  double Result = 0;
  double AveragePrice = 0;
  double Count = 0;
  for (int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN_Sell)
          if(OrderType() == OP_SELL) 
          {
            AveragePrice += OrderOpenPrice() * OrderLots();
            Count += OrderLots();
          }
  if(AveragePrice > 0 && Count > 0)
    Result = NormalizeDouble(AveragePrice / Count, Digits);
  return(Result);
}
//+------------------------------------------------------------------+
int SendMarketOrder(int Type, double Lots, int TP, int SL, int Magic, string Cmnt, int& Error)
{
  double Price, Take, Stop;
  int Ticket, Slippage, Color, Err; 
  bool Delay = False;
  //if(Debug) Print(" SendMarketOrder");
  while(!IsStopped())
  {
    if(!IsExpertEnabled())
    {
      Error = ERR_TRADE_DISABLED;
      Print("!LET ME TRADE!");
      return(-1);
    }
    //if(Debug) Print("  ");
    if(!IsConnected())
      Print("!NO CONNECTION!");
    //if(Debug) Print("   ");
    if(IsTradeContextBusy())
    {
      Print("Trade Context Busy!");
      Sleep(3000);
      Delay = True;
      continue;
    }
    //if(Debug) Print("  ");
    if(Delay || (LastTickTime != MarketInfo(Symbol(),MODE_TIME))) 
    {
      //if(Debug) Print(" ");
      RefreshRates();
      LastTickTime = MarketInfo(Symbol(),MODE_TIME);
      Delay = False;
    }
    else
    {
      //if(Debug) Print(" ");
    }
    switch(Type)
    {
      case OP_BUY:
        //if(Debug) Print("   BUY-");
        Price = NormalizeDouble( Ask, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble( Price + TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble( Price - SL * Point, Digits));
        Color = Blue;
        break;
      case OP_SELL:
        //if(Debug) Print("   SELL-");
        Price = NormalizeDouble( Bid, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble( Price - TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble( Price + SL * Point, Digits));
        Color = Red;
        break;
      default:
        Print("!INVALID ORDER TYPE!");
        return(-1);
    }
    Slippage = MarketInfo(Symbol(), MODE_SPREAD);
    if(Debug) Print("Slippage = ",Slippage);
    if(IsTradeAllowed())
    {
      //if(Debug) Print(" ,  ...");
      Ticket = OrderSend(Symbol(), Type, Lots, Price, Slippage, Stop, Take, Cmnt, Magic, 0, Color);
      if(Ticket < 0)
      {
        Err = GetLastError();
        if (Err == 4   || //SERVER_BUSY
            Err == 129 || //INVALID_PRICE 
            Err == 135 || //PRICE_CHANGED 
            Err == 137 || //BROKER_BUSY 
            Err == 138 || //REQUOTE 
            Err == 146 || //TRADE_CONTEXT_BUSY
            Err == 136 )  //OFF_QUOTES
        {
          Print("!ERROR!(OrderSend - ", Err, "): ", ErrorDescription(Err));
          Print("Waiting 3 sec...");
          Sleep(3000);
          Delay = True;
          continue;
        }
        else
        {
          Print("!CRITICAL ERROR!(OrderSend - ", Err, "): ", ErrorDescription(Err));
          Error = Err;
          break;
        }
      }
      break;
    }
    else
    {
      Print("!LET ME TRADE!");
      break;
    }
  }
  //if(Ticket > 0)
    //if(Debug) Print("Order sent OK, Ticket = ",Ticket);
  if(!(Ticket > 0))
    Print("!ERROR! ORDER NOT SENT! (ErrorCode = ", Error, ": ", ErrorDescription(Error), ")");
  return(Ticket);
}
//+------------------------------------------------------------------+
double IIFd(bool condition, double ifTrue, double ifFalse) 
{
  if (condition) return(ifTrue); else return(ifFalse);
}
//---------------------------------------------------
bool ModifyOrder( double TakeProfit)
{
  if((OrderTakeProfit() == TakeProfit) && (OrderStopLoss() == 0))
    return(true);
  while(!IsStopped())
  {
    //if(Debug) Print("Function ModifyOrder");
    if(!IsTesting())
    {
      if(IsTradeContextBusy())
      {
        Print("Trade context busy, waiting 3 sec...");
        Sleep(3000);
        continue;
      }
      //if(Debug) Print("Trade context OK");
      if(!IsTradeAllowed())
      {
        Print("!LET ME TRADE!");
        Sleep(3000);
        continue;
      }
      //if(Debug) Print("Modifying Order # ",OrderTicket());
    }
    if(!OrderModify(OrderTicket(), OrderOpenPrice(), 0, NormalizeDouble(TakeProfit, Digits), 0, Yellow))
    {
      Print("!ORDER MODIFICATION FAILED!");
      int Err = GetLastError();
      Print("Error(",Err,"): ",ErrorDescription(Err));
      break;
    }
    else
    {
      if(Debug) Print("Order Modification OK");
      break;
    }
  }
  return(true);
}
//-------------------
int GetSignal()
{
  int sig = 0;
  if(SignalMode == 0) sig = GetRandomSignal();
  if(SignalMode == 1) sig = BarsCheck_ir0407();
  if(SignalMode == 2) sig = BarsCheck_scumen();
  if(SignalMode == 3) sig = BarsCheck_Jerk();
  return(sig);
}
//-------------------
int GetRandomSignal()
{
  int res;
  int sig = 0;
  MathSrand(TimeLocal());       //   
  res = MathMod(MathRand(),2); //     2
  
  if(res == 0) // E  ,    
  {
    //if(Debug) Print("Random Signal: BUY");     
    sig = 1;
  }
  if(res == 1) // E  ,    
  {
    //if(Debug) Print("Random Signal: SELL");     
    sig = -1;
  }  
  return(sig);
}
//----------------------
int BarsCheck_ir0407()
{
  int sig = 0;
  double Bar1Close = NormalizeDouble(iClose(Symbol(), 0, 1), Digits);
  double Bar2Close = NormalizeDouble(iClose(Symbol(), 0, 2), Digits);
  if(Bar1Close > Bar2Close)
    if(NormalizeDouble((Bar1Close - Bar2Close) / Point, 0) >= 30) 
    {
//      if(Debug) Print("BarsCheck_ir0407: BUY");  
      sig = 1;
    }
  if(Bar1Close < Bar2Close) 
    if(NormalizeDouble((Bar2Close - Bar1Close) / Point, 0) >= 30) 
//      if(Debug) Print("BarsCheck_ir0407: SELL");
      sig = -1;
  return(sig);
}
//----------------------
int BarsCheck_scumen()
{ 
  int sig = 0;
  double Bar1Close = NormalizeDouble(iClose(Symbol(), 0, 1), Digits);
  double Bar2Close = NormalizeDouble(iClose(Symbol(), 0, 2), Digits);
  if(Bar1Close > Bar2Close)
  {
//    if(Debug) Print("BarsCheck_scumen: BUY");  
    sig = 1;
  }
  if(Bar1Close < Bar2Close)
  {
//    if(Debug) Print("BarsCheck_scumen: SELL");  
    sig = -1;
  }
  return(sig);
}
//--------------------
int BarsCheck_Jerk()
{
  int sig = 0;
  int num = NumberOfBars;
  int tf = mper[TF_Bars];
  double delta = DeltaBarPrice;
  
  double Bar1_High = NormalizeDouble(iHigh(Symbol(), tf, 1), Digits);
  double Bar1_Low  = NormalizeDouble(iLow(Symbol(), tf, 1), Digits);
  double BarN_High = NormalizeDouble(iHigh(Symbol(), tf, num), Digits);
  double BarN_Low  = NormalizeDouble(iLow(Symbol(), tf, num), Digits);

  if(NormalizeDouble((Bar1_High - BarN_Low) / Point, 0) > delta)
  {
//    if(Debug) Print("BarsCheck_Jerk: SELL"); 
    sig = -1;
  }
  if(NormalizeDouble((BarN_High - Bar1_Low) / Point, 0) > delta)
  {
//    if(Debug) Print("BarsCheck_Jerk: BUY");
    sig = 1;
  }
  return(sig);
}
//-------------

